com.fasterxml.jackson.databind.type

## Class CollectionType

- java.lang.Object
- - com.fasterxml.jackson.core.type.ResolvedType
  - - com.fasterxml.jackson.databind.JavaType
    - - com.fasterxml.jackson.databind.type.TypeBase
      - - com.fasterxml.jackson.databind.type.CollectionLikeType
        - - com.fasterxml.jackson.databind.type.CollectionType

- All Implemented Interfaces:
    JsonSerializable, Serializable, Type

      public final class CollectionType
      extends CollectionLikeType

  Type that represents Java Collection types (Lists, Sets).
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.JsonSerializable

      `JsonSerializable.Base`

  - ### Field Summary

    - ### Fields inherited from class com.fasterxml.jackson.databind.type.CollectionLikeType

      `_elementType`

    - ### Fields inherited from class com.fasterxml.jackson.databind.type.TypeBase

      `_bindings, _superClass, _superInterfaces`

    - ### Fields inherited from class com.fasterxml.jackson.databind.JavaType

      `_asStatic, _class, _hash, _typeHandler, _valueHandler`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `CollectionType(TypeBase base, JavaType elemT)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected JavaType` | `_narrow(Class<?> subclass)` Deprecated.
    `static CollectionType` | `construct(Class<?> rawType, JavaType elemT)` Deprecated. Since 2.7, remove from 2.9
    `static CollectionType` | `construct(Class<?> rawType, TypeBindings bindings, JavaType superClass, JavaType[] superInts, JavaType elemT)`
    `JavaType` | `refine(Class<?> rawType, TypeBindings bindings, JavaType superClass, JavaType[] superInterfaces)` Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
    `String` | `toString()`
    `JavaType` | `withContentType(JavaType contentType)` Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one.
    `CollectionType` | `withContentTypeHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.
    `CollectionType` | `withContentValueHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
    `CollectionType` | `withStaticTyping()` Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use.
    `CollectionType` | `withTypeHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
    `CollectionType` | `withValueHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

    - ### Methods inherited from class com.fasterxml.jackson.databind.type.CollectionLikeType

      `buildCanonicalName, equals, getContentType, getContentTypeHandler, getContentValueHandler, getErasedSignature, getGenericSignature, hasHandlers, isCollectionLikeType, isContainerType, isTrueCollectionType, upgradeFrom, withHandlersFrom`

    - ### Methods inherited from class com.fasterxml.jackson.databind.type.TypeBase

      `_bogusSuperClass, _classSignature, containedType, containedTypeCount, containedTypeName, findSuperType, findTypeParameters, getBindings, getInterfaces, getSuperClass, serialize, serializeWithType, toCanonical`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JavaType

      `containedTypeOrUnknown, forcedNarrowBy, getErasedSignature, getGenericSignature, getKeyType, getParameterSource, getRawClass, getReferencedType, getTypeHandler, getValueHandler, hasContentType, hasGenericTypes, hashCode, hasRawClass, hasValueHandler, isAbstract, isArrayType, isConcrete, isEnumImplType, isEnumType, isFinal, isInterface, isJavaLangObject, isMapLikeType, isPrimitive, isThrowable, isTypeOrSubTypeOf, isTypeOrSuperTypeOf, useStaticType`

    - ### Methods inherited from class com.fasterxml.jackson.core.type.ResolvedType

      `isReferenceType`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.reflect.Type

      `getTypeName`

- - ### Constructor Detail

    - #### CollectionType

          protected CollectionType(TypeBase base,
                                   JavaType elemT)

      Since:
        2.7

  - ### Method Detail

    - #### construct

          public static CollectionType construct(Class<?> rawType,
                                                 TypeBindings bindings,
                                                 JavaType superClass,
                                                 JavaType[] superInts,
                                                 JavaType elemT)

      Since:
        2.7

    - #### construct

          @Deprecated
          public static CollectionType construct(Class<?> rawType,
                                                             JavaType elemT)

      Deprecated. Since 2.7, remove from 2.9

    - #### _narrow

          @Deprecated
          protected JavaType _narrow(Class<?> subclass)

      Deprecated.
      Overrides:
        `_narrow` in class `CollectionLikeType`

    - #### withContentType

          public JavaType withContentType(JavaType contentType)

      Description copied from class: `JavaType`
      Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one. If content type is already set to given type, `this` is returned. If type does not have a content type (which is the case with `SimpleType`), `IllegalArgumentException` will be thrown.
      Overrides:
        `withContentType` in class `CollectionLikeType`
      Returns:
        Newly created type instance

    - #### withTypeHandler

          public CollectionType withTypeHandler(Object h)

      Description copied from class: `JavaType`
      "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
      Overrides:
        `withTypeHandler` in class `CollectionLikeType`
      Returns:
        Newly created type instance

    - #### withContentTypeHandler

          public CollectionType withContentTypeHandler(Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.
      Overrides:
        `withContentTypeHandler` in class `CollectionLikeType`
      Returns:
        Newly created type instance, with given

    - #### withValueHandler

          public CollectionType withValueHandler(Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.
      Overrides:
        `withValueHandler` in class `CollectionLikeType`
      Returns:
        Newly created type instance

    - #### withContentValueHandler

          public CollectionType withContentValueHandler(Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
      Overrides:
        `withContentValueHandler` in class `CollectionLikeType`
      Returns:
        Newly created type instance

    - #### withStaticTyping

          public CollectionType withStaticTyping()

      Description copied from class: `JavaType`
      Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use. The main use case is to allow forcing of specific root value serialization type, and specifically in resolving serializers for contained types (element types for arrays, Collections and Maps).
      Overrides:
        `withStaticTyping` in class `CollectionLikeType`

    - #### refine

          public JavaType refine(Class<?> rawType,
                                 TypeBindings bindings,
                                 JavaType superClass,
                                 JavaType[] superInterfaces)

      Description copied from class: `JavaType`
      Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
      Overrides:
        `refine` in class `CollectionLikeType`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `CollectionLikeType`

Copyright © 2008–2020 FasterXML. All rights reserved.